import { useRef } from 'react';
export const useDelayEventHandler = (event, { delayUntilRepeat }) => {
    const shoudleFireEvent = useRef(true);
    //
    const fireEvent = (argv) => {
        if (delayUntilRepeat === -1) {
            event(argv);
            return;
        }
        if (shoudleFireEvent.current) {
            shoudleFireEvent.current = false;
            //
            event(argv);
            //
            setTimeout(() => {
                shoudleFireEvent.current = true;
            }, delayUntilRepeat);
        }
    };
    return fireEvent;
};
export const useDelayEventHandlerEx = ({ delayUntilRepeat, }) => {
    const shoudleFireEvents = useRef(new Map()).current;
    //
    const createEventKeyIfAny = (eventKey) => {
        if (!shoudleFireEvents.has(eventKey)) {
            shoudleFireEvents.set(eventKey, true);
        }
    };
    const fireEvent = (eventConfig) => {
        createEventKeyIfAny(eventConfig.eventKey);
        //
        const _delayUntilRepeat = eventConfig.delayUntilRepeat || delayUntilRepeat;
        if (_delayUntilRepeat === -1) {
            eventConfig.event();
            return;
        }
        //
        const shoudleFireEvent = shoudleFireEvents.get(eventConfig.eventKey);
        if (shoudleFireEvent) {
            shoudleFireEvents.set(eventConfig.eventKey, false);
            //
            eventConfig.event();
            //
            setTimeout(() => {
                shoudleFireEvents.set(eventConfig.eventKey, true);
            }, _delayUntilRepeat);
        }
    };
    return fireEvent;
};
